Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ApplicationConstants.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ApplicationConstants.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ApplicationConstants.cs	(revision 4598)
@@ -33,5 +33,5 @@
     public static System.Transactions.IsolationLevel ISOLATION_LEVEL_SCOPE = System.Transactions.IsolationLevel.ReadUncommitted;
 
-    public static int HEARTBEAT_MAX_DIF = 120; // value in seconds
+    public static int HEARTBEAT_TIMEOUT = 120; // value in seconds
     
     public static int JOB_TIME_TO_LIVE = 5;
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/HivePluginData.cs	(revision 4598)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/Job.cs	(revision 4598)
@@ -34,5 +34,5 @@
     public Guid UserId { get; set; }
     [DataMember]
-    public Slave Slave { get; set; }
+    public Guid SlaveId { get; set; }
     [DataMember]
     public int Priority { get; set; }
@@ -42,17 +42,17 @@
     public int MemoryNeeded { get; set; }
     [DataMember]
-    public List<HivePlugin> PluginsNeeded { get; set; }
+    public List<Guid> PluginsNeededIds { get; set; }
     [DataMember]
     public List<Guid> AssignedResourceIds { get; set; }
     [DataMember]
-    public Project Project { get; set; }
+    public Guid ProjectId { get; set; }
 
     public override string ToString() {
-      return base.ToString() + "State: " + State + ", [Ressource : " + Slave + " ] , DateCreated: " + DateCreated + ", DateCalculated: " + DateCalculated +
+      return base.ToString() + "State: " + State + ", [SlaveId : " + SlaveId + " ] , DateCreated: " + DateCreated + ", DateCalculated: " + DateCalculated +
         "Priority: " + Priority + ", CoresNeeded: " + CoresNeeded + "AssignedResources: " + AssignedResourceIds;
     }
 
     public Job() {
-      PluginsNeeded = new List<HivePlugin>();
+      PluginsNeededIds = new List<Guid>();
       AssignedResourceIds = new List<Guid>();
     }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobData.cs	(revision 4598)
@@ -23,5 +23,4 @@
 using System.IO;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -30,5 +29,5 @@
   public class JobData : HiveItem {
     [DataMember]
-    public Job Job { get; set; }
+    public Guid JobId { get; set; }
     [DataMember]
     public byte[] Data { get; set; }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/JobState.cs	(revision 4598)
@@ -31,5 +31,5 @@
     /// Job is waiting to be calculated
     /// </summary>
-    Offline,
+    Waiting,
 
     /// <summary>
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/DataTransfer/LightweightJob.cs	(revision 4598)
@@ -43,4 +43,17 @@
     [DataMember]
     public Guid? ParentJobId { get; set; }
+
+    public LightweightJob() { }
+
+    public LightweightJob(Job job) {
+      this.SlaveId = job.SlaveId;
+      this.State = job.State;
+      this.ExecutionTime = job.ExecutionTime;
+      this.Exception = job.Exception;
+      this.DateCreated = job.DateCreated;
+      this.DateCalculated = job.DateCalculated;
+      this.DateFinished = job.DateFinished;
+      this.ParentJobId = job.ParentJobId;
+    }
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/Disposable.cs	(revision 4598)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.Hive.Common {
+  public class Disposable<T> : IDisposable {
+    private T obj;
+    public T Obj {
+      get { return obj; }
+    }
+
+    public Disposable(T obj) {
+      this.obj = obj;
+    }
+
+    public void Dispose() {
+      if (OnDisposing != null)
+        OnDisposing(this, new EventArgs());
+    }
+
+    public event EventHandler OnDisposing;
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/HeuristicLab.Services.Hive.Common-3.3.csproj	(revision 4598)
@@ -66,4 +66,5 @@
     <Compile Include="DataTransfer\LightweightJob.cs" />
     <Compile Include="DataTransfer\JobState.cs" />
+    <Compile Include="Disposable.cs" />
     <Compile Include="MessageContainer.cs" />
     <Compile Include="DataTransfer\NamedHiveItem.cs" />
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.Common/3.3/ServiceContracts/IHiveService.cs	(revision 4598)
@@ -15,43 +15,68 @@
     #region Job Methods
     [OperationContract]
-    Job AddJob(JobData job);
+    Guid AddJob(Job jobDto, JobData jobDataDto);
+
     [OperationContract]
-    Job AddJobWithGroupStrings(JobData jobObj, IEnumerable<string> groups);
+    Guid AddChildJob(Guid parentJobId, Job jobDto, JobData jobDataDto);
+
+    [OperationContract] // formerly GetJobById
+    Job GetJob(Guid jobId);
+
+    [OperationContract] // formerly GetAllJobs
+    IEnumerable<Job> GetJobs();
+
+    [OperationContract] // formerly GetJobResults
+    IEnumerable<LightweightJob> GetLightweightJobs(IEnumerable<Guid> jobIds);
+
+    [OperationContract] // formerly GetChildJobResults
+    IEnumerable<LightweightJob> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent);
+
+    [OperationContract] // formerly GetLastSerializedResult
+    JobData GetJobData(Guid jobId);
+
     [OperationContract]
-    JobData GetLastSerializedResult(Guid jobId);
+    Stream GetJobDataStreamed(Guid jobId);
+
+    [OperationContract]
+    void UpdateJob(Job jobDto, JobData jobDataDto);
+        
+    [OperationContract] // formerly StoreFinishedJobResultStreamed
+    void UpdateJobDataStreamed(Stream stream);
+
+    [OperationContract]
+    void DeleteChildJobs(Guid parentJobId);
+
+    [OperationContract] // new method: appropriate job is choosen and set to 'calculating'. the slave is responsible for requesting the jobData. Server should wait some timeout until he redistributes the job
+    Job AquireJob(Guid slaveId);
+
+    //[OperationContract] // dump?
+    //Job GetJobByIdWithDetails(Guid jobId);
+
+    //[OperationContract] dump?
+    //Job AddNewJob(JobData job);
+
+    //[OperationContract]
+    //void RemoveJob(Guid jobId);
+
+    //[OperationContract] // GetJobForCalculation (was this used?
+    //Job GetJob(Guid slaveId);
+
+    //[OperationContract] --> replaced by UpdateJob
+    //void StoreFinishedJobResult(Guid slaveId, Guid jobId, byte[] result, TimeSpan executionTime, string exception);
+
+    //[OperationContract] dump this! a slave should just check if job is still offline, if so it can submit the finished job, otherwise throw away! its a rare case that a slave reawakes with a finished job
+    //void IsJobStillNeeded(Guid jobId);
+
+    //[OperationContract] // dump?
+    //Job AddJobWithGroupStrings(JobData jobObj, IEnumerable<string> groups);
+    #endregion
+
+
+    #region Job Control Methods
     [OperationContract]
     void AbortJob(Guid jobId);
-    [OperationContract]
-    Job GetJobById(Guid jobId);
-    [OperationContract]
-    IEnumerable<LightweightJob> GetJobResults(IEnumerable<Guid> jobIds);
-    [OperationContract]
-    IEnumerable<LightweightJob> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent);
-    [OperationContract]
-    Job AddChildJob(Guid parentJobId, JobData serializedJob);
-    [OperationContract]
-    Job GetAllJobsWithFilter(JobState jobState, int offset, int count);
-    [OperationContract]
-    Job GetAllJobs();
-    [OperationContract]
-    Job GetJobByIdWithDetails(Guid jobId);
-    [OperationContract]
-    Job AddNewJob(JobData job);
-    //[OperationContract]
-    //void RemoveJob(Guid jobId);
+
     [OperationContract]
     Job PauseJob(JobData serializedJob);
-    [OperationContract]
-    void DeleteChildJobs(Guid jobId);
-    [OperationContract]
-    Job GetJob(Guid clientId);
-    [OperationContract]
-    void StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception);
-    [OperationContract]
-    void IsJobStillNeeded(Guid jobId);
-    [OperationContract]
-    Stream GetStreamedJob(Guid clientId);
-    [OperationContract]
-    void StoreFinishedJobResultStreamed(Stream stream);
     #endregion
 
@@ -62,6 +87,8 @@
     [OperationContract]
     IEnumerable<HiveExperiment> GetHiveExperiments();
+
     [OperationContract]
-    HiveExperiment UpdateHiveExperiment(HiveExperiment hiveExperimentDto);
+    void UpdateHiveExperiment(HiveExperiment hiveExperimentDto);
+
     [OperationContract]
     void DeleteHiveExperiment(Guid hiveExperimentId);
@@ -123,23 +150,26 @@
     #region Slave Methods
     [OperationContract]
-    IEnumerable<Slave> GetAllSlaves();
+    Guid AddSlaveGroup(SlaveGroup slaveGroup);
+
     [OperationContract]
-    [ServiceKnownType(typeof(Resource))]
-    [ServiceKnownType(typeof(Slave))]
-    [ServiceKnownType(typeof(SlaveGroup))]
-    IEnumerable<SlaveGroup> GetAllSlaveGroups();
+    IEnumerable<Slave> GetSlaves();
+    
     [OperationContract]
-    IEnumerable<SlaveGroup> GetAllGroupsOfResource(Guid resourceId);
-    [OperationContract]
-    SlaveGroup AddSlaveGroup(SlaveGroup clientGroup);
+    //[ServiceKnownType(typeof(Resource))] - not sure about those
+    //[ServiceKnownType(typeof(Slave))]
+    //[ServiceKnownType(typeof(SlaveGroup))]
+    IEnumerable<SlaveGroup> GetSlaveGroups();
+
     [OperationContract]
     void DeleteSlaveGroup(Guid clientGroupId);
+
     [OperationContract]
-    [ServiceKnownType(typeof(Resource))]
-    [ServiceKnownType(typeof(Slave))]
-    [ServiceKnownType(typeof(SlaveGroup))]
-    void AddResourceToGroup(Guid clientGroupId, Resource resource);
+    //[ServiceKnownType(typeof(Resource))]
+    //[ServiceKnownType(typeof(Slave))]
+    //[ServiceKnownType(typeof(SlaveGroup))]
+    void AddResourceToGroup(Guid slaveGroupId, Resource resource);
+
     [OperationContract]
-    void DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId);
+    void RemoveResourceFromGroup(Guid slaveGroupId, Guid resourceId);
     #endregion
     
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/ContextFactory.cs	(revision 4598)
@@ -31,4 +31,6 @@
 
 namespace HeuristicLab.Services.Hive.DataAccess {
+  public delegate T CreateDataContext<T>() where T : DataContext;
+
   /// <summary>
   /// This class handles creates one Context for each Thread which asks for one.
@@ -39,19 +41,13 @@
   /// it has to be disposed in order to finish the corresponding transaction.
   /// </summary>
-  public class ContextFactory : IContextFactory {
+  public class ContextFactory<T> : IContextFactory<T> where T : DataContext {
     private static object locker = new object();
-    private static IDictionary<int, HiveDataContext> contexts = new Dictionary<int, HiveDataContext>();
+    private static IDictionary<int, Disposable<T>> contexts = new Dictionary<int, Disposable<T>>();
     private static IDictionary<int, TransactionScope> transactions = new Dictionary<int, TransactionScope>();
+    private CreateDataContext<T> createDataContext;
 
-    private static IContextFactory instance = null;
-    public static IContextFactory Instance {
-      get {
-        if (instance == null)
-          instance = new ContextFactory();
-        return instance;
-      }
+    public ContextFactory(CreateDataContext<T> createDataContext) {
+      this.createDataContext = createDataContext;
     }
-
-    #region IContextManager Members
 
     public IDisposable GetContext() {
@@ -69,7 +65,9 @@
         }
 
-        DisposableHiveDataContext context = CreateContext();
-        context.OnDisposing += new EventHandler(context_OnDisposing);
-        contexts.Add(threadId, context);
+        T context = createDataContext();
+       
+        Disposable<T> disposableContext = new Disposable<T>(context);
+        disposableContext.OnDisposing += new EventHandler(context_OnDisposing);
+        contexts.Add(threadId, disposableContext);
 
         if (withTransaction) {
@@ -79,8 +77,4 @@
         return context;
       }
-    }
-
-    private static DisposableHiveDataContext CreateContext() {
-      return new DisposableHiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
     }
 
@@ -102,5 +96,5 @@
       lock (locker) {
         int threadId = Thread.CurrentThread.ManagedThreadId;
-
+        contexts[threadId].Dispose();
         contexts.Remove(threadId);
         // context gets disposed implicitly, when it is used as IDisposable
@@ -126,12 +120,12 @@
     }
 
-    public DataContext CurrentContext {
+    public T CurrentContext {
       get {
         lock (locker) {
           int threadId = Thread.CurrentThread.ManagedThreadId;
           if (contexts.ContainsKey(threadId)) {
-            return contexts[threadId];
+            return contexts[threadId].Obj;
           } else {
-            return null;
+            return default(T);
           }
         }
@@ -139,21 +133,7 @@
     }
 
-    #endregion
-  }
-
-  /// <summary>
-  /// Offers an event when it gets disposed
-  /// </summary>
-  class DisposableHiveDataContext : HiveDataContext {
-
-    public DisposableHiveDataContext(string connection) : base(connection) { }
-
-    protected override void Dispose(bool disposing) {
-      base.Dispose(disposing);
-      if (OnDisposing != null)
-        OnDisposing(this, new EventArgs());
+    public static HiveDataContext CreateHiveContext() {
+      return new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
     }
-
-    public event EventHandler OnDisposing;
   }
 }
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs	(revision 4598)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/Convert.cs	(revision 4598)
@@ -0,0 +1,127 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Linq;
+using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
+
+namespace HeuristicLab.Services.Hive.DataAccess {
+  public static class Convert {
+
+   
+    #region Job
+    public static DT.Job ToDto(Job source) {
+      if (source == null) return null;
+      return new DT.Job { Id = source.JobId };// todo
+    }
+    public static Job ToEntity(DT.Job source) {
+      if (source == null) return null;
+      return new Job { JobId = source.Id };// todo
+    }
+    public static void ToEntity(DT.Job source, Job target) {
+      if ((source != null) && (target != null)) {
+        target.JobId = source.Id;// todo
+      }
+    }
+    #endregion
+
+    #region JobData
+    public static DT.JobData ToDto(JobData source) {
+      if (source == null) return null;
+      return new DT.JobData { JobId = source.JobId };// todo
+    }
+    public static JobData ToEntity(DT.JobData source) {
+      if (source == null) return null;
+      return new JobData { JobId = source.Id };// todo
+    }
+    public static void ToEntity(DT.JobData source, JobData target) {
+      if ((source != null) && (target != null)) {
+        target.JobId = source.Id;// todo
+      }
+    }
+    #endregion
+    
+    #region HiveExperiment
+    public static DT.HiveExperiment ToDto(HiveExperiment source) {
+      if (source == null) return null;
+      return new DT.HiveExperiment { Id = source.HiveExperimentId };// todo
+    }
+    public static HiveExperiment ToEntity(DT.HiveExperiment source) {
+      if (source == null) return null;
+      return new HiveExperiment { HiveExperimentId = source.Id };// todo
+    }
+    public static void ToEntity(DT.HiveExperiment source, HiveExperiment target) {
+      if ((source != null) && (target != null)) {
+        target.HiveExperimentId = source.Id;// todo
+      }
+    }
+    #endregion
+
+    #region Slave
+    public static DT.Slave ToDto(Slave source) {
+      if (source == null) return null;
+      return new DT.Slave { Id = source.ResourceId };// todo
+    }
+    public static Slave ToEntity(DT.Slave source) {
+      if (source == null) return null;
+      return new Slave { ResourceId = source.Id };// todo
+    }
+    public static void ToEntity(DT.Slave source, Slave target) {
+      if ((source != null) && (target != null)) {
+        target.ResourceId = source.Id;// todo
+      }
+    }
+    #endregion
+
+    #region SlaveGroup
+    public static DT.SlaveGroup ToDto(SlaveGroup source) {
+      if (source == null) return null;
+      return new DT.SlaveGroup { Id = source.ResourceId };// todo
+    }
+    public static SlaveGroup ToEntity(DT.SlaveGroup source) {
+      if (source == null) return null;
+      return new SlaveGroup { ResourceId = source.Id };// todo
+    }
+    public static void ToEntity(DT.SlaveGroup source, SlaveGroup target) {
+      if ((source != null) && (target != null)) {
+        target.ResourceId = source.Id;// todo
+      }
+    }
+    #endregion
+
+    #region Resource
+    public static DT.Resource ToDto(Resource source) {
+      if (source == null) return null;
+      return new DT.Resource { Id = source.ResourceId };// todo
+    }
+    public static Resource ToEntity(DT.Resource source) {
+      if (source == null) return null;
+      return new Resource { ResourceId = source.Id };// todo
+    }
+    public static void ToEntity(DT.Resource source, Resource target) {
+      if ((source != null) && (target != null)) {
+        target.ResourceId = source.Id;// todo
+      }
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj
===================================================================
--- branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4595)
+++ branches/HeuristicLab.Hive/sources/HeuristicLab.Hive.New/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 4598)
@@ -56,5 +56,7 @@
   <ItemGroup>
     <Compile Include="ContextFactory.cs" />
+    <Compile Include="Convert.cs" />
     <Compile Include="HeuristicLabServicesHiveDataAccessPlugin.cs" />
+    <Compile Include="HiveDao.cs" />
     <Compile Include="HiveDataContext.cs">
       <DependentUpon>HiveDataContext.dbml</DependentUpon>
@@ -66,4 +68,5 @@
     </Compile>
     <Compile Include="Interfaces\IContextFactory.cs" />
+    <Compile Include="Interfaces\IHiveDao.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
